/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  libmagic Qore wrapper

  Qore Programming Language

  Copyright 2012 - 2016 Qore Technologies

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include "qoremagic.h"
/* Qore class Qore::Magic::Magic */

qore_classid_t CID_MAGIC;
QoreClass* QC_MAGIC;

// string Magic::buffer(data data){}
static AbstractQoreNode* Magic_buffer_Vt(QoreObject* self, QoreMagic* priv, const QoreListNode* args, ExceptionSink* xsink) {
   const AbstractQoreNode* data = get_param(args, 0);
# 143 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
   return priv->buffer(data, xsink);
}

// string Magic::buffer(data data, softint flags){}
static AbstractQoreNode* Magic_buffer_Vtvi(QoreObject* self, QoreMagic* priv, const QoreListNode* args, ExceptionSink* xsink) {
   const AbstractQoreNode* data = get_param(args, 0);
   int64 flags = HARD_QORE_INT(args, 1);
# 152 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
   return priv->buffer(data, flags, xsink);
}

// Magic::constructor() {}
static void Magic_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 104 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
self->setPrivate(CID_MAGIC, new QoreMagic(xsink));
}

// Magic::constructor(softint flags) {}
static void Magic_constructor_vi(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   int64 flags = HARD_QORE_INT(args, 0);
# 111 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
self->setPrivate(CID_MAGIC, new QoreMagic((int)flags, xsink));
}

// string Magic::file(softstring fileName){}
static AbstractQoreNode* Magic_file_vs(QoreObject* self, QoreMagic* priv, const QoreListNode* args, ExceptionSink* xsink) {
   const QoreStringNode* fileName = HARD_QORE_STRING(args, 0);
# 126 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
   return priv->file(fileName, xsink);
}

// string Magic::file(softstring fileName, softint flags){}
static AbstractQoreNode* Magic_file_vsvi(QoreObject* self, QoreMagic* priv, const QoreListNode* args, ExceptionSink* xsink) {
   const QoreStringNode* fileName = HARD_QORE_STRING(args, 0);
   int64 flags = HARD_QORE_INT(args, 1);
# 135 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
   return priv->file(fileName, flags, xsink);
}

// nothing Magic::setFlags(softint flags){}
static AbstractQoreNode* Magic_setFlags_vi(QoreObject* self, QoreMagic* priv, const QoreListNode* args, ExceptionSink* xsink) {
   int64 flags = HARD_QORE_INT(args, 0);
# 118 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
   priv->setFlags(flags, xsink);
   return 0;
}

DLLLOCAL QoreClass* initMagicClass(QoreNamespace& ns) {
   QC_MAGIC = new QoreClass("Magic", QDOM_FILESYSTEM);
   CID_MAGIC = QC_MAGIC->getID();

   // string Magic::buffer(data data){}
   QC_MAGIC->addMethodExtended3("buffer", (q_method_t)Magic_buffer_Vt, false, QC_NO_FLAGS, QDOM_FILESYSTEM, stringTypeInfo, 1, dataTypeInfo, NULL, "data");

   // string Magic::buffer(data data, softint flags){}
   QC_MAGIC->addMethodExtended3("buffer", (q_method_t)Magic_buffer_Vtvi, false, QC_NO_FLAGS, QDOM_FILESYSTEM, stringTypeInfo, 2, dataTypeInfo, NULL, "data", softBigIntTypeInfo, NULL, "flags");

   // Magic::constructor() {}
   QC_MAGIC->setConstructorExtended3(Magic_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // Magic::constructor(softint flags) {}
   QC_MAGIC->setConstructorExtended3(Magic_constructor_vi, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, softBigIntTypeInfo, NULL, "flags");

   // string Magic::file(softstring fileName){}
   QC_MAGIC->addMethodExtended3("file", (q_method_t)Magic_file_vs, false, QC_NO_FLAGS, QDOM_FILESYSTEM, stringTypeInfo, 1, softStringTypeInfo, NULL, "fileName");

   // string Magic::file(softstring fileName, softint flags){}
   QC_MAGIC->addMethodExtended3("file", (q_method_t)Magic_file_vsvi, false, QC_NO_FLAGS, QDOM_FILESYSTEM, stringTypeInfo, 2, softStringTypeInfo, NULL, "fileName", softBigIntTypeInfo, NULL, "flags");

   // nothing Magic::setFlags(softint flags){}
   QC_MAGIC->addMethodExtended3("setFlags", (q_method_t)Magic_setFlags_vi, false, QC_NO_FLAGS, QDOM_DEFAULT, nothingTypeInfo, 1, softBigIntTypeInfo, NULL, "flags");
# 29 "/export/home/dnichols/src/el7/qore/git/module-magic/src/magic.qpp"
   ns.addConstant("MAGIC_APPLE", new QoreBigIntNode(0x000800));
   ns.addConstant("MAGIC_CHECK", new QoreBigIntNode(0x000040));
   ns.addConstant("MAGIC_COMPRESS", new QoreBigIntNode(0x000004));
   ns.addConstant("MAGIC_CONTINUE", new QoreBigIntNode(0x000020));
   ns.addConstant("MAGIC_DEBUG", new QoreBigIntNode(0x000001));
   ns.addConstant("MAGIC_DEVICES", new QoreBigIntNode(0x000008));
   ns.addConstant("MAGIC_ERROR", new QoreBigIntNode(0x000200));
   ns.addConstant("MAGIC_MIME", new QoreBigIntNode(0x000410));
   ns.addConstant("MAGIC_MIME_ENCODING", new QoreBigIntNode(0x000400));
   ns.addConstant("MAGIC_MIME_TYPE", new QoreBigIntNode(0x000010));
   ns.addConstant("MAGIC_NONE", new QoreBigIntNode(0x000000));
   ns.addConstant("MAGIC_NO_CHECK_APPTYPE", new QoreBigIntNode(0x008000));
   ns.addConstant("MAGIC_NO_CHECK_BUILTIN", new QoreBigIntNode(0x3fb000));
   ns.addConstant("MAGIC_NO_CHECK_CDF", new QoreBigIntNode(0x040000));
   ns.addConstant("MAGIC_NO_CHECK_COMPRESS", new QoreBigIntNode(0x001000));
   ns.addConstant("MAGIC_NO_CHECK_ELF", new QoreBigIntNode(0x010000));
   ns.addConstant("MAGIC_NO_CHECK_ENCODING", new QoreBigIntNode(0x200000));
   ns.addConstant("MAGIC_NO_CHECK_SOFT", new QoreBigIntNode(0x004000));
   ns.addConstant("MAGIC_NO_CHECK_TAR", new QoreBigIntNode(0x002000));
   ns.addConstant("MAGIC_NO_CHECK_TEXT", new QoreBigIntNode(0x020000));
   ns.addConstant("MAGIC_NO_CHECK_TOKENS", new QoreBigIntNode(0x100000));
   ns.addConstant("MAGIC_PRESERVE_ATIME", new QoreBigIntNode(0x000080));
   ns.addConstant("MAGIC_RAW", new QoreBigIntNode(0x000100));
   ns.addConstant("MAGIC_SYMLINK", new QoreBigIntNode(0x000002));

   return QC_MAGIC;
}
